/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, String_$type, Delegate_$type, fromEnum, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox } from "igniteui-webcomponents-core";
import { List$1 } from "igniteui-webcomponents-core";
import { Tuple$2 } from "igniteui-webcomponents-core";
import { SVGNode } from "igniteui-webcomponents-core";
import { FastIterationDictionary$2 } from "igniteui-webcomponents-core";
import { isNaN_ } from "igniteui-webcomponents-core";
import { IIcon_$type } from "igniteui-webcomponents-core";
import { BaseControlTheme_$type } from "igniteui-webcomponents-core";
import { NativeUI } from "igniteui-webcomponents-core";
import { IconClickedEventArgs } from "./IconClickedEventArgs";
import { IconVisualModelExport } from "./IconVisualModelExport";
import { AppearanceHelper } from "igniteui-webcomponents-core";
import { FontUtil } from "igniteui-webcomponents-core";
import { stringStartsWith } from "igniteui-webcomponents-core";
import { trimStart } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let IconView = /*@__PURE__*/ (() => {
    class IconView extends Base {
        constructor() {
            super();
            this.b = null;
            this.o = null;
            this.e = null;
            this.i = new List$1(Delegate_$type, 0);
            this.j = null;
            this.k = null;
            this.l = null;
            this.m = null;
            this.n = null;
            this.c = null;
            this.d = null;
            this.u = null;
            this.t = null;
            this.f = true;
            this.p = null;
            this.q = null;
            this.j = new List$1(Tuple$2.$.specialize(SVGNode.$, Base.$), 0);
            this.k = new List$1(Tuple$2.$.specialize(SVGNode.$, Base.$), 0);
            this.l = new List$1(Tuple$2.$.specialize(SVGNode.$, Base.$), 0);
            this.m = new List$1(Tuple$2.$.specialize(SVGNode.$, Base.$), 0);
            this.n = new List$1(Tuple$2.$.specialize(SVGNode.$, Base.$), 0);
            this.c = new FastIterationDictionary$2(String_$type, List$1.$.specialize(Tuple$2.$.specialize(SVGNode.$, Base.$)), 0);
            this.d = new FastIterationDictionary$2(String_$type, List$1.$.specialize(Tuple$2.$.specialize(SVGNode.$, Base.$)), 0);
        }
        ac() {
        }
        g() {
            return true;
        }
        get r() {
            return this.p;
        }
        get s() {
            return null;
        }
        get h() {
            return true;
        }
        aa(a) {
            if (a == null) {
                for (let b of fromEnum(this.i)) {
                    b();
                }
                this.i.clear();
                if (this.p != null) {
                    this.p.unlistenAll();
                }
            }
            this.o = a;
            a.rootWrapper.setStyleProperty("position", "relative");
            this.o.rootWrapper.setStyleProperty("display", "flex");
            this.o.rootWrapper.setStyleProperty("flex-direction", "row");
            this.o.rootWrapper.setStyleProperty("flex-wrap", "no-wrap");
            this.o.rootWrapper.setStyleProperty("align-items", "center");
            this.ae();
            let c = this.o.createElementNS("svg", "http://www.w3.org/2000/svg");
            c.setStyleProperty("position", "absolute");
            c.setStyleProperty("top", "0");
            c.setStyleProperty("left", "0");
            c.setStyleProperty("right", "0");
            c.setStyleProperty("bottom", "0");
            this.p = c;
            this.ai();
            let d = this.o.createElementNS("path", "http://www.w3.org/2000/svg");
            d.setAttribute("d", "");
            this.p.append(d);
            if (this.u != null) {
                d.setAttribute("d", this.u);
            }
            this.q = d;
            this.o.append(this.p);
            this.i.add(c.listen("click", runOn(this, this.z)));
            this.b.b6();
        }
        ag(a) {
            if (this.u != a) {
                this.u = a;
                this.o.rootWrapper.removeChildren();
                this.o.rootWrapper.append(this.p);
                if (this.q != null) {
                    this.q.setAttribute("d", this.u);
                }
            }
        }
        af(a) {
            if (this.t != a) {
                this.t = a;
                this.o.rootWrapper.removeChildren();
                let b = this.o.rootWrapper.getNativeElement();
                b.innerHTML = this.t;
            }
        }
        ae() {
            this.o.rootWrapper.setStyleProperty("width", isNaN_(this.b.ao) ? "1.5rem" : this.b.ao + "px");
            this.o.rootWrapper.setStyleProperty("height", isNaN_(this.b.ag) ? "1.5rem" : this.b.ag + "px");
        }
        ai() {
            this.p.setAttribute("viewBox", (isNaN_(this.b.al) ? 0 : this.b.al) + " " + (isNaN_(this.b.am) ? 0 : this.b.am) + " " + (isNaN_(this.b.an) ? 24 : this.b.an) + " " + (isNaN_(this.b.ak) ? 24 : this.b.ak));
        }
        v(a) {
        }
        ad() {
            if (this.g()) {
            }
        }
        w(a) {
            this.b.b3();
        }
        x(a) {
            this.b.b4();
        }
        y() {
            this.f = true;
            this.i.add(this.o.rootWrapper.listen("mouseenter", runOn(this, this.w)));
            this.i.add(this.o.rootWrapper.listen("mouseleave", runOn(this, this.x)));
        }
        ab() {
            this.f = false;
            for (let a of fromEnum(this.i)) {
                a();
            }
            this.i.clear();
        }
        ah(a) {
            if (a != null) {
                this.o.rootWrapper.setStyleProperty("font", a.fontString);
            }
        }
        a() {
            let rect_ = this.o.rootWrapper.getNativeElement().getBoundingClientRect();
            let a = (rect_.top);
            let b = (rect_.left);
            let c = new Array(2);
            c[0] = a;
            c[1] = b;
            return c;
        }
        z(a) {
            this.b.b1();
        }
    }
    IconView.$t = /*@__PURE__*/ markType(IconView, 'IconView');
    return IconView;
})();
/**
 * @hidden
 */
export let XIcon = /*@__PURE__*/ (() => {
    class XIcon extends Base {
        constructor() {
            super();
            this._view = null;
            this.h = 0;
            this.cc = XIcon.cs;
            this.cd = XIcon.cw;
            this.ce = XIcon.cx;
            this.t = XIcon.af;
            this.cf = XIcon.cs;
            this.cn = XIcon.cw;
            this.x = XIcon.af;
            this.co = XIcon.cx;
            this.cg = XIcon.ct;
            this.ch = XIcon.cu;
            this.v = XIcon.ae;
            this.ci = null;
            this.a = null;
            this.b = null;
            this.cj = null;
            this.ck = null;
            this.cl = null;
            this.cm = null;
            this.aw = null;
            this.av = null;
            this.j = null;
            this.au = "ig-icon-" + XIcon.ar++;
            this.ap = 0;
            this.l = false;
            this.at = null;
            this.n = false;
            this.m = false;
            this.w = 1;
            this.z = NaN;
            this.aa = NaN;
            this.ab = NaN;
            this.y = NaN;
            this.ac = NaN;
            this.u = NaN;
            this.clicked = null;
            this.propertyChanged = null;
            let a = new IconView();
            a.b = this;
            this.view = a;
            this.view.ac();
        }
        get view() {
            return this._view;
        }
        set view(a) {
            this._view = a;
        }
        destroy() {
            this.provideContainer(null);
        }
        b5(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.b7(a, b, c);
        }
        b7(a, b, c) {
            switch (a) {
                case "Fill":
                case "Stroke":
                case "StrokeWidth":
                case "HoverFill":
                case "HoverStroke":
                case "HoverStrokeThickness":
                case "IsHover":
                    this.cb();
                    break;
                case "ActualFill":
                case "ActualStroke":
                case "ActualStrokeWidth":
                case "SVGPath":
                case "SVG":
                    this.b9();
                    break;
                case "Opacity":
                    this.ca();
                    break;
                case "ViewBoxLeft":
                case "ViewBoxTop":
                case "ViewBoxWidth":
                case "ViewBoxHeight":
                    this.view.ai();
                    break;
                case "Width":
                case "Height":
                    this.view.ae();
                    break;
            }
        }
        cb() {
            let a = this.fill != null ? this.fill : XIcon.cs;
            let b = this.c5 != null ? this.c5 : XIcon.cw;
            let c = !isNaN_(this.aj) ? this.aj : XIcon.af;
            let d = this.c6 != null ? this.c6 : XIcon.cx;
            if (this.r) {
                this.cp = this.cy != null ? this.cy : a;
                this.cq = this.cz != null ? this.cz : b;
                this.ad = !isNaN_(this.ah) ? this.ah : c;
                this.cr = this.c0 != null ? this.c0 : d;
            }
            else {
                this.cp = a;
                this.cq = b;
                this.ad = c;
                this.cr = d;
            }
        }
        get p() {
            return this.svgPath != null && !this.view.h;
        }
        ca() {
            NativeUI.y(this.view.r, this.ai);
        }
        b9() {
            let a = this.view.r;
            if (this.p) {
                let b = this.view.s;
                NativeUI.r(b, this.cp);
                NativeUI.aa(b, this.cq);
                NativeUI.ad(b, this.ad);
            }
            else {
                let c = false;
                if (this.svgPath != null) {
                    if (stringStartsWith(trimStart(this.svgPath, ' ', '\n', '\r', '\t'), "<svg")) {
                        this.view.af(this.svgPath);
                        c = true;
                    }
                    else {
                        this.view.ag(this.svgPath);
                    }
                }
                else if (this.svg != null) {
                    this.view.af(this.svg);
                    c = true;
                }
                if (c) {
                    for (let d = 0; d < this.view.k.count; d++) {
                        let e = this.view.k._inner[d].c;
                        NativeUI.r(this.view.k._inner[d].d, e.l.f(this.c1));
                    }
                    for (let f = 0; f < this.view.l.count; f++) {
                        let g = this.view.l._inner[f].c;
                        NativeUI.aa(this.view.l._inner[f].d, g.m.f(this.c2));
                    }
                    for (let h = 0; h < this.view.m.count; h++) {
                        let i = this.view.m._inner[h].c;
                        NativeUI.r(this.view.m._inner[h].d, i.l.f(this.c3));
                    }
                    for (let j = 0; j < this.view.n.count; j++) {
                        let k = this.view.n._inner[j].c;
                        NativeUI.aa(this.view.n._inner[j].d, k.m.f(this.c4));
                    }
                    for (let l = 0; l < this.view.c.o.count; l++) {
                        let m = this.view.c.o._inner[l];
                        let n = m.split('-');
                        let o = parseInt(n[n.length - 1]);
                        if (o < this.c.count) {
                            for (let p = 0; p < this.view.c.q._inner[l].count; p++) {
                                let q = this.view.c.q._inner[l]._inner[p].c;
                                NativeUI.r(this.view.c.q._inner[l]._inner[p].d, q.l.f(this.c.item(o)));
                            }
                        }
                    }
                    for (let r = 0; r < this.view.d.o.count; r++) {
                        let s = this.view.d.o._inner[r];
                        let t = s.split('-');
                        let u = parseInt(t[t.length - 1]);
                        if (u < this.d.count) {
                            for (let v = 0; v < this.view.d.q._inner[r].count; v++) {
                                let w = this.view.d.q._inner[r]._inner[v].c;
                                NativeUI.aa(this.view.d.q._inner[r]._inner[v].d, w.m.f(this.d.item(u)));
                            }
                        }
                    }
                    for (let x = 0; x < this.view.j.count; x++) {
                        let y = this.view.j._inner[x].c;
                        NativeUI.r(this.view.j._inner[x].d, y.l.f(this.cp));
                        NativeUI.aa(this.view.j._inner[x].d, y.m.f(this.cq));
                    }
                }
                let z = this.view.r;
                if (this.cp != null) {
                    NativeUI.r(z, this.cp);
                }
                if (this.cq != null) {
                    NativeUI.aa(z, this.cq);
                }
                if (!isNaN_(this.ad)) {
                    NativeUI.ad(z, this.ad);
                }
            }
            if (this.k != null) {
                this.view.ah(this.k);
            }
            if (this.cr != null) {
                NativeUI.q(this.view.r, this.cr);
            }
        }
        get i() {
            return this.h;
        }
        set i(a) {
            let b = this.h;
            this.h = a;
            if (b != this.h) {
                this.b5("BaseTheme", enumGetBox(BaseControlTheme_$type, b), enumGetBox(BaseControlTheme_$type, a));
            }
        }
        get cp() {
            return this.cc;
        }
        set cp(a) {
            let b = this.cc;
            this.cc = a;
            if (b != this.cc) {
                this.b5("ActualFill", b, a);
            }
        }
        get cq() {
            return this.cd;
        }
        set cq(a) {
            let b = this.cd;
            this.cd = a;
            if (b != this.cd) {
                this.b5("ActualStroke", b, a);
            }
        }
        get cr() {
            return this.ce;
        }
        set cr(a) {
            let b = this.ce;
            this.ce = a;
            if (b != this.ce) {
                this.b5("ActualTextColor", b, a);
            }
        }
        get ad() {
            return this.t;
        }
        set ad(a) {
            let b = this.t;
            this.t = a;
            if (b != this.t) {
                this.b5("ActualStrokeWidth", b, a);
            }
        }
        get fill() {
            return this.cf;
        }
        set fill(a) {
            let b = this.cf;
            this.cf = a;
            if (b != this.cf) {
                this.b5("Fill", b, a);
            }
        }
        get c5() {
            return this.cn;
        }
        set c5(a) {
            let b = this.cn;
            this.cn = a;
            if (b != this.cn) {
                this.b5("Stroke", b, a);
            }
        }
        get aj() {
            return this.x;
        }
        set aj(a) {
            let b = this.x;
            this.x = a;
            if (b != this.x) {
                this.b5("StrokeWidth", b, a);
            }
        }
        get c6() {
            return this.co;
        }
        set c6(a) {
            let b = this.co;
            this.co = a;
            if (b != this.co) {
                this.b5("TextColor", b, a);
            }
        }
        get cy() {
            return this.cg;
        }
        set cy(a) {
            let b = this.cg;
            this.cg = a;
            if (b != this.cg) {
                this.b5("HoverFill", b, a);
            }
        }
        get cz() {
            return this.ch;
        }
        set cz(a) {
            let b = this.ch;
            this.ch = a;
            if (b != this.ch) {
                this.b5("HoverStroke", b, a);
            }
        }
        get ah() {
            return this.v;
        }
        set ah(a) {
            let b = this.v;
            this.v = a;
            if (b != this.v) {
                this.b5("HoverStrokeThickness", b, a);
            }
        }
        get c0() {
            return this.ci;
        }
        set c0(a) {
            let b = this.ci;
            this.ci = a;
            if (b != this.ci) {
                this.b5("HoverTextColor", b, a);
            }
        }
        get c() {
            return this.a;
        }
        set c(a) {
            let b = this.a;
            this.a = a;
            if (b != this.a) {
                this.b5("FillColors", b, this.a);
            }
        }
        get d() {
            return this.b;
        }
        set d(a) {
            let b = this.b;
            this.b = a;
            if (b != this.b) {
                this.b5("StrokeColors", b, this.b);
            }
        }
        get c1() {
            return this.cj;
        }
        set c1(a) {
            let b = this.cj;
            this.cj = a;
            if (b != this.cj) {
                this.b5("PrimaryFillColor", b, this.cj);
            }
        }
        get c2() {
            return this.ck;
        }
        set c2(a) {
            let b = this.ck;
            this.ck = a;
            if (b != this.ck) {
                this.b5("PrimaryStrokeColor", b, this.ck);
            }
        }
        get c3() {
            return this.cl;
        }
        set c3(a) {
            let b = this.cl;
            this.cl = a;
            if (b != this.cl) {
                this.b5("SecondaryFillColor", b, this.cl);
            }
        }
        get c4() {
            return this.cm;
        }
        set c4(a) {
            let b = this.cm;
            this.cm = a;
            if (b != this.cm) {
                this.b5("SecondaryStrokeColor", b, this.cm);
            }
        }
        get svgPath() {
            return this.aw;
        }
        set svgPath(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.b5("SVGPath", b, a);
            }
        }
        get svg() {
            return this.av;
        }
        set svg(a) {
            let b = this.av;
            this.av = a;
            if (b != this.av) {
                this.b5("SVG", b, this.av);
            }
        }
        b3() {
            this.r = true;
        }
        b4() {
            this.r = false;
        }
        get k() {
            return this.j;
        }
        set k(a) {
            let b = this.j;
            this.j = a;
            if (b != this.j) {
                this.b5("TextStyle", b, a);
            }
        }
        get bc() {
            return this.au;
        }
        set bc(a) {
            let b = this.au;
            this.au = a;
            if (b != this.au) {
                this.b5("Id", b, a);
            }
        }
        get o() {
            return this.l;
        }
        get aq() {
            return this.ap;
        }
        set aq(a) {
            let b = this.ap;
            this.ap = a;
            this.l = true;
            if (b != this.ap) {
                this.b5("TabIndex", b, a);
            }
        }
        get a1() {
            return this.at;
        }
        set a1(a) {
            let b = this.at;
            this.at = a;
            if (b != this.at) {
                this.b5("AriaLabel", b, a);
            }
        }
        get r() {
            return this.n;
        }
        set r(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.b5("IsHover", b, a);
            }
        }
        get disabled() {
            return this.m;
        }
        set disabled(a) {
            let b = this.m;
            this.m = a;
            if (b != this.m) {
                this.b5("IsDisabled", b, a);
            }
        }
        get ai() {
            return this.w;
        }
        set ai(a) {
            let b = this.w;
            this.w = a;
            if (b != this.w) {
                this.b5("Opacity", b, this.w);
            }
        }
        get al() {
            return this.z;
        }
        set al(a) {
            let b = this.z;
            this.z = a;
            if (b != this.z) {
                this.b5("ViewBoxLeft", b, this.z);
            }
        }
        get am() {
            return this.aa;
        }
        set am(a) {
            let b = this.aa;
            this.aa = a;
            if (b != this.aa) {
                this.b5("ViewBoxTop", b, this.aa);
            }
        }
        get an() {
            return this.ab;
        }
        set an(a) {
            let b = this.ab;
            this.ab = a;
            if (b != this.ab) {
                this.b5("ViewBoxWidth", b, this.ab);
            }
        }
        get ak() {
            return this.y;
        }
        set ak(a) {
            let b = this.y;
            this.y = a;
            if (b != this.y) {
                this.b5("ViewBoxHeight", b, this.y);
            }
        }
        get ao() {
            return this.ac;
        }
        set ao(a) {
            let b = this.ac;
            this.ac = a;
            if (b != this.ac) {
                this.b5("Width", b, this.ac);
            }
        }
        get ag() {
            return this.u;
        }
        set ag(a) {
            let b = this.u;
            this.u = a;
            if (b != this.u) {
                this.b5("Height", b, this.u);
            }
        }
        b6() {
        }
        onDetachedFromUI() {
            this.view.ab();
        }
        onAttachedToUI() {
            this.view.y();
        }
        b1() {
            if (this.disabled) {
                return;
            }
            if (this.clicked != null) {
                this.clicked(this, new IconClickedEventArgs());
            }
        }
        s() {
            return this.view.g();
        }
        as() {
            return this.e();
        }
        a4() {
            let a = this.e();
            return a.j();
        }
        e() {
            let a = new IconVisualModelExport();
            let b = this.view.r;
            a.a = AppearanceHelper.a(NativeUI.al(b));
            a.c = AppearanceHelper.a(NativeUI.al(b));
            a.b = AppearanceHelper.a(NativeUI.am(b));
            a.d = this.ad;
            let c = this.view.a();
            a.h = c[0];
            a.f = c[1];
            a.e = NativeUI.d(b);
            a.i = NativeUI.k(b);
            a.svgPath = this.svgPath;
            if (this.k != null) {
                let d = this.k;
                if (this.view != null && d.n == null) {
                    let e = this.view.o;
                    let f = FontUtil.getFontInfoFromString(e, d.fontString);
                    d.n = f.n;
                    d.d = f.d;
                    d.o = f.o;
                    d.q = f.q;
                    d.r = f.r;
                    d.s = f.s;
                }
                if (d.n != null) {
                    a.l = d.n;
                }
                if (!isNaN_(d.d)) {
                    a.g = d.d;
                }
                if (d.s != null) {
                    a.p = d.s;
                }
                if (d.q != null) {
                    a.n = d.q;
                }
                if (d.o != null) {
                    a.m = d.q;
                }
            }
            return a;
        }
        provideContainer(a) {
            this.view.aa(a);
        }
    }
    XIcon.$t = /*@__PURE__*/ markType(XIcon, 'XIcon', Base.$, [INotifyPropertyChanged_$type, IIcon_$type]);
    XIcon.cs = null;
    XIcon.cx = null;
    XIcon.cw = null;
    XIcon.ct = null;
    XIcon.cu = null;
    XIcon.cv = null;
    XIcon.af = NaN;
    XIcon.ae = NaN;
    XIcon.ar = 0;
    return XIcon;
})();
