import { InputChangeEventArgs as InputChangeEventArgs_internal } from "./InputChangeEventArgs";
import { ensureBool } from "igniteui-webcomponents-core";
var IgcInputChangeEventArgs = /** @class */ /*@__PURE__*/ (function () {
    function IgcInputChangeEventArgs() {
        this._implementation = this.createImplementation();
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    }
    IgcInputChangeEventArgs.prototype.createImplementation = function () {
        return new InputChangeEventArgs_internal();
    };
    Object.defineProperty(IgcInputChangeEventArgs.prototype, "i", {
        /**
         * @hidden
         */
        get: function () {
            return this._implementation;
        },
        enumerable: false,
        configurable: true
    });
    IgcInputChangeEventArgs.prototype.onImplementationCreated = function () {
    };
    IgcInputChangeEventArgs.prototype._provideImplementation = function (i) {
        this._implementation = i;
        this._implementation.externalObject = this;
        this.onImplementationCreated();
        if (this._initializeAdapters) {
            this._initializeAdapters();
        }
    };
    Object.defineProperty(IgcInputChangeEventArgs.prototype, "value", {
        get: function () {
            return this.i.value;
        },
        set: function (v) {
            this.i.value = v;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(IgcInputChangeEventArgs.prototype, "isCompositionInProgress", {
        get: function () {
            return this.i.isCompositionInProgress;
        },
        set: function (v) {
            this.i.isCompositionInProgress = ensureBool(v);
        },
        enumerable: false,
        configurable: true
    });
    return IgcInputChangeEventArgs;
}());
export { IgcInputChangeEventArgs };
