import { __extends } from "tslib";
import { IgCollection } from "igniteui-webcomponents-core";
import { markType } from "igniteui-webcomponents-core";
import { SyncableObservableCollection$2 } from "igniteui-webcomponents-core";
import { XButton as XButton_internal } from './XButton';
import { IgcXButtonComponent as IgcXButtonComponent } from './igc-x-button-component';
var IgcXButtonGroupButtonCollection = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(IgcXButtonGroupButtonCollection, _super);
    function IgcXButtonGroupButtonCollection(list) {
        var _this = _super.call(this) || this;
        if (!IgcXButtonComponent.$type) {
            IgcXButtonComponent.$type = markType(IgcXButtonComponent, "IgcXButtonComponent");
        }
        if (list) {
            for (var i = 0; i < list.length; i++) {
                _this.add(list[i]);
            }
        }
        return _this;
    }
    IgcXButtonGroupButtonCollection.prototype._createInnerColl = function () {
        if (!IgcXButtonComponent.$type) {
            IgcXButtonComponent.$type = markType(IgcXButtonComponent, "IgcXButtonComponent");
        }
        var coll = new SyncableObservableCollection$2(IgcXButtonComponent.$type, XButton_internal.$type, 0);
        coll.compare = function (ext, int) {
            var comp = ext;
            if (comp._implementation) {
                comp = comp._implementation;
            }
            if (comp.equals) {
                return comp.equals(int);
            }
            return comp === int;
        };
        coll.createTo = function (ext) {
            return ext._implementation;
        };
        coll.createFrom = function (int) {
            var ext = int.externalObject;
            if (!ext) {
                ext = IgcXButtonComponent._createFromInternal(int);
                if (ext) {
                    ext._implementation = int;
                }
            }
            return ext;
        };
        return coll;
    };
    return IgcXButtonGroupButtonCollection;
}(IgCollection));
export { IgcXButtonGroupButtonCollection };
