import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-webcomponents-core";
import { DomRenderer, DomWrapper } from "igniteui-webcomponents-core";
import { XInputGroup } from "./XInputGroup";
import { XLabel } from "./XLabel";
import { XInput } from "./XInput";
import { XSuffix } from "./XSuffix";
import { XIcon } from "./XIcon";
import { Popup } from "igniteui-webcomponents-core";
import { XCalendar } from "./XCalendar";
import { Rect } from "igniteui-webcomponents-core";
import { Brush } from "igniteui-webcomponents-core";
import { FontInfo } from "igniteui-webcomponents-core";
import { ControlDisplayDensity } from "igniteui-webcomponents-core";
import { BaseControlTheme } from "igniteui-webcomponents-core";
import { DayOfWeek } from "./DayOfWeek";
import { FirstWeek } from "./FirstWeek";
import { DateFormats } from "./DateFormats";
import { SelectedValueChangedEventArgs } from "./SelectedValueChangedEventArgs";
import { InputChangeEventArgs } from "./InputChangeEventArgs";
import { KeyEventArgs } from "igniteui-webcomponents-core";
import { GotFocusEventArgs } from "./GotFocusEventArgs";
import { LostFocusEventArgs } from "./LostFocusEventArgs";
import { DatePickerVisualModelExport } from "./DatePickerVisualModelExport";
/**
 * @hidden
 */
export declare class DatePickerView extends Base {
    static $t: Type;
    constructor();
    b: DatePicker;
    ak(): void;
    d: DomRenderer;
    private k;
    private e;
    private m;
    private l;
    private j;
    private g;
    private f;
    private i;
    private h;
    get n(): DomWrapper;
    private o;
    ai(a: DomRenderer): void;
    private ab;
    ao(a: XInputGroup): void;
    aq(a: XLabel): void;
    ap(a: XInput): void;
    as(a: XSuffix, b: any): void;
    an(a: XIcon, b: any): void;
    v(): any;
    u(): any;
    r(): any;
    q(): any;
    t(): any;
    s(): any;
    au(a: boolean): void;
    aw(a: string): void;
    at(): void;
    af(): void;
    av(): void;
    al(): void;
    ah(): void;
    private ac;
    z(): void;
    ar(a: Popup): void;
    am(a: XCalendar): void;
    p(): any;
    private aa;
    private ae;
    private y;
    private w;
    private x;
    private aj;
    private document_Click;
    ax(): Rect;
    a(): number[];
    private c;
    ag(): void;
}
/**
 * @hidden
 */
export declare class DatePicker extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private h;
    private static readonly bj;
    private static readonly bk;
    private u;
    private q;
    private o;
    private r;
    private m;
    private n;
    private c;
    private a9;
    private bd;
    private bg;
    private ba;
    private bf;
    private ah;
    private ap;
    private ao;
    private ay;
    private ai;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    selectedValueChanged: (sender: any, args: SelectedValueChangedEventArgs) => void;
    cz(a: Date, b: Date): void;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    setName(a: string): void;
    private ae;
    private get af();
    private a0;
    get value(): Date;
    set value(a: Date);
    private az;
    get a3(): Date;
    set a3(a: Date);
    private bc;
    get bv(): string;
    set bv(a: string);
    private de;
    get dh(): Brush;
    set dh(a: Brush);
    private static ab;
    private z;
    get ac(): FontInfo;
    set ac(a: FontInfo);
    private be;
    get b2(): string;
    set b2(a: string);
    private ax;
    get a2(): Date;
    set a2(a: Date);
    private aw;
    get a1(): Date;
    set a1(a: Date);
    private x;
    get y(): ControlDisplayDensity;
    set y(a: ControlDisplayDensity);
    private v;
    get w(): BaseControlTheme;
    set w(a: BaseControlTheme);
    private aa;
    get ad(): FontInfo;
    set ad(a: FontInfo);
    private df;
    get di(): Brush;
    set di(a: Brush);
    private dd;
    get dg(): Brush;
    set dg(a: Brush);
    private al;
    get at(): boolean;
    set at(a: boolean);
    private am;
    get au(): boolean;
    set au(a: boolean);
    private ag;
    get aq(): boolean;
    set aq(a: boolean);
    private ak;
    get as(): boolean;
    set as(a: boolean);
    private i;
    get j(): DayOfWeek;
    set j(a: DayOfWeek);
    private k;
    get l(): FirstWeek;
    set l(a: FirstWeek);
    private an;
    get av(): boolean;
    set av(a: boolean);
    private a;
    private d;
    get e(): DateFormats;
    set e(a: DateFormats);
    private bb;
    get br(): string;
    set br(a: string);
    private aj;
    get ar(): boolean;
    set ar(a: boolean);
    private a6;
    get a7(): number;
    set a7(a: number);
    protected cy(a: string, b: any, c: any): void;
    protected c1(a: string, b: any, c: any): void;
    private ce;
    private da;
    private c7;
    private c9;
    ch(): void;
    private cq;
    private cp;
    private co;
    dc(a: string): void;
    private db;
    private c8;
    cf(): void;
    ci(): void;
    private cd;
    private cc;
    cn(): void;
    c0(): void;
    cg(): void;
    focus(a?: boolean): void;
    cm(): void;
    c3(): void;
    cl(): void;
    ct(): void;
    cu(): void;
    private c6;
    private c4;
    a8(): any;
    bo(): string;
    b(): DatePickerVisualModelExport;
    gotFocus: (sender: any, args: GotFocusEventArgs) => void;
    lostFocus: (sender: any, args: LostFocusEventArgs) => void;
    keyDown: (sender: any, args: KeyEventArgs) => void;
    changing: (sender: any, args: InputChangeEventArgs) => void;
    cv(a: GotFocusEventArgs): void;
    cx(a: LostFocusEventArgs): void;
    cw(a: KeyEventArgs): void;
    cs(a: InputChangeEventArgs): void;
}
