import { XSuffix } from "./XSuffix";
import { IgcXInputGroupItemComponent } from './igc-x-input-group-item-component';
export declare class IgcXSuffixComponent extends IgcXInputGroupItemComponent {
    private _portalManager;
    private _container;
    private _renderer;
    constructor();
    private _onChildrenChanged;
    updateStyle(): void;
    destroy(): void;
    private _wrapper;
    protected createImplementation(): XSuffix;
    private _suffix;
    private _disconnected;
    disconnectedCallback(): void;
    connectedCallback(): void;
    afterContentInit(): void;
    /**
                             * @hidden
                             */
    get i(): XSuffix;
    private static _observedAttributesIgcXSuffixComponent;
    static get observedAttributes(): string[];
    static htmlTagName: string;
    protected static _isElementRegistered: boolean;
    static register(): void;
    /**
 * Gets or sets the id to use for the checkbox.
*/
    get id(): string;
    set id(v: string);
    /**
     * Gets or sets the value of the aria-label attribute.
    */
    get ariaLabel(): string;
    set ariaLabel(v: string);
    /**
     * Gets or sets whether the suffix is hovered.
    */
    get isHover(): boolean;
    set isHover(v: boolean);
    /**
     * Gets or sets whether the checkbox is disabled.
    */
    get disabled(): boolean;
    set disabled(v: boolean);
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    /**
     * Exports visual information about the current state of the grid.
    
    */
    exportVisualModel(): any;
    /**
     * Returns a serialized copy of the exported visual model
    
    */
    exportSerializedVisualModel(): string;
}
